%define _disable_ld_no_undefined 1

%define major		1
%define	gmajor		1.0
%define libname		%mklibname gdm %{major}
%define develname	%mklibname -d %{name}
%define girname		%mklibname gdm-gir %{gmajor}

%define url_ver	%(echo %{version}|cut -d. -f1,2)

Summary:	The GNOME Display Manager
Name:		gdm
Version:	3.12.2
Release:	3
Epoch:		1
License:	GPLv2+
Group:		Graphical desktop/GNOME
URL:		http://www.gnome.org/projects/gdm/
Source0:	ftp://ftp.gnome.org/pub/GNOME/sources/%{name}/%{url_ver}/%{name}-%{version}.tar.xz
Source1:	org.gnome.login-screen.gschema.override
Source2:	rosa-logo.png
# git format-patch --start-number 300 mga-3.1.2-plymouth..mga-3.1.2-patches
Patch0301:	0301-Novell-Look-at-the-current-runlevel-before-managing-.patch
Patch0302:	0302-Fix-gdm-pam.d-configs-3.12.2.patch
Patch0303:	0303-Read-.xsetup-scripts.patch
Patch0900:	gdm-3.8.1.1-drop-plymouth-conflicts.patch

Provides:	dm

Requires(postun): rpm-helper systemd update-alternatives
Requires(post):	  dconf systemd update-alternatives

Requires:	pam
Requires:	sessreg
Requires:	usermode
Requires:	cdialog
Requires:	zenity
Requires:	gnome-session-bin
Requires:	gnome-settings-daemon
Requires:	metacity
Suggests:	gnome-power-manager
# for XFdrake on failsafe fallback:
Requires:	drakx-kbd-mouse-x11
Requires:	xinitrc >= 2.4.14
Requires:	dbus-x11
Requires:	polkit-gnome
Requires:	accountsservice
Requires:	gnome-icon-theme-symbolic
Provides:	gdm-Xnest
Obsoletes:	gdm-Xnest

Obsoletes:	gdm-themes
Conflicts:	gdm-220
BuildRequires: 	pkgconfig(accountsservice) >= 0.6.12
BuildRequires:	pkgconfig(check) >= 0.9.4
BuildRequires:	pkgconfig(dbus-glib-1) >= 0.74
BuildRequires:	pkgconfig(fontconfig) >= 2.5.0
BuildRequires:	pkgconfig(gconf-2.0) >= 2.31.3
BuildRequires:	pkgconfig(gio-2.0) >= 2.29.3
BuildRequires:	pkgconfig(gobject-2.0) >= 2.29.3
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(gthread-2.0)
BuildRequires:	pkgconfig(gtk+-3.0) >= 2.91.1
BuildRequires:	pkgconfig(libcanberra-gtk3) >= 0.4
BuildRequires:	pkgconfig(libxklavier) >= 4.0
BuildRequires:	pkgconfig(nss) >= 3.11.1
BuildRequires:	pkgconfig(libsystemd-login)
BuildRequires:	pkgconfig(libsystemd-daemon)
BuildRequires:	pkgconfig(ply-boot-client)
BuildRequires:	pkgconfig(upower-glib) >= 0.9.0
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xau)
BuildRequires:	pkgconfig(xdmcp)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pam-devel
BuildRequires:	libwrap-devel
BuildRequires:	audit-devel
BuildRequires:	intltool >= 0.40.0
BuildRequires:	gettext-devel
BuildRequires:	yelp-tools
BuildRequires:	dconf
BuildRequires:	itstool
BuildRequires:	gnome-common

Obsoletes:	gdm-user-switch-applet < 3.0.0
Obsoletes:	%{_lib}gdmsimplegreeter1

Requires:	%{_lib}gmenu-gir3.0 >= 3.8.0

%description
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

%pre
%_pre_useradd gdm %{_var}/lib/gdm /bin/false
%_pre_groupadd xgrp gdm

%post
# avoiding conflict with lightdm
if [ $1 -eq 1 ] ; then \
update-alternatives --install %{_bindir}/gdmflexiserver gdmflexiserver %{_libexecdir}/%{name}/gdmflexiserver 30
fi

# (cg) Setup dconf settings for gdm
# http://git.gnome.org/browse/gdm/commit/?id=eebeb62e2daccc932f3033fbd857b619ba9936d0
dconf update

if [ -f /%{_sysconfdir}/X11/xdm/Xsession -a ! -x /%{_sysconfdir}/X11/xdm/Xsession ]; then
        chmod +x /%{_sysconfdir}/X11/xdm/Xsession
fi
if [ -x /usr/sbin/chksession ]; then /usr/sbin/chksession -g || true; fi

%systemd_post gdm.service

%{_sbindir}/gdm-safe-restart >/dev/null 2>&1 || :

%postun
%_postun_userdel gdm
%_postun_groupdel xgrp gdm
%systemd_postun gdm.service

%preun
if [ $1 -ge 0 ] ; then \
	if [ ! -e %{_libexecdir}/%{name}/gdmflexiserver ]; then
		update-alternatives --remove gdmflexiserver %{_libexecdir}/%{name}/gdmflexiserver
	fi
fi
%systemd_preun gdm.service

%files -f %{name}.lang
%doc AUTHORS COPYING NEWS README
%_sysconfdir/dbus-1/system.d/gdm.conf
%{_bindir}/gdm-screenshot
%{_sbindir}/gdm
%dir %{_sysconfdir}/X11/gdm
%{_sysconfdir}/gdm
%config(noreplace) %{_sysconfdir}/pam.d/gdm
%config(noreplace) %{_sysconfdir}/pam.d/gdm-autologin
%config(noreplace) %{_sysconfdir}/pam.d/gdm-pin
%config(noreplace) %{_sysconfdir}/pam.d/gdm-fingerprint
%config(noreplace) %{_sysconfdir}/pam.d/gdm-password
%config(noreplace) %{_sysconfdir}/pam.d/gdm-smartcard
%config(noreplace) %{_sysconfdir}/pam.d/gdm-launch-environment
%config(noreplace) %{_sysconfdir}/X11/gdm/custom.conf
%config(noreplace) %{_sysconfdir}/X11/gdm/Xsession
%dir %{_sysconfdir}/X11/dm
%dir %{_sysconfdir}/X11/dm/Sessions
%config(noreplace) %{_sysconfdir}/X11/gdm/PreSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostLogin
%config(noreplace) %{_sysconfdir}/X11/gdm/Init
%{_libexecdir}/gdm-host-chooser
%{_libexecdir}/gdm-session-worker
%{_libexecdir}/gdm-simple-chooser
%{_libexecdir}/gdm/gdmflexiserver
%dir %{_libdir}/gdm
%{_datadir}/pixmaps/*
%{_datadir}/gdm
%{_datadir}/glib-2.0/schemas/org.gnome.login-screen.gschema.xml
%dir %{_datadir}/hosts
%attr(1770, gdm, gdm) %dir %{_localstatedir}/lib/gdm
%attr(1755, gdm, gdm) %dir %{_localstatedir}/run/gdm/greeter
%attr(1777, root, gdm) %dir %{_localstatedir}/run/gdm
%attr(1755, root, gdm) %dir %{_localstatedir}/cache/gdm
%attr(700,gdm,gdm) %dir %{_localstatedir}/lib/gdm/.local
%attr(700,gdm,gdm) %dir %{_localstatedir}/lib/gdm/.local/share
%attr(700,gdm,gdm) %dir %{_localstatedir}/lib/gdm/.local/share/applications
%{_datadir}/dconf/profile/gdm
#%ghost %{_sysconfdir}/dconf/db/%{name}
#%dir %{_sysconfdir}/dconf/db/gdm.d
#%{_sysconfdir}/dconf/db/gdm.d/00-upstream-settings
#%dir %{_sysconfdir}/dconf/db/gdm.d/locks
%{_datadir}/gnome-session/sessions/gdm-shell.session
%dir %{_var}/log/gdm
%{_datadir}/icons/hicolor/*/apps/gdm*
# (cg) Note: Ship this, but lets not enable it or do anything fancy
# until we fully redo any prefdm stuff and have units for all DMs
# we support.
%{_unitdir}/gdm.service
%{_datadir}/glib-2.0/schemas/org.gnome.login-screen.gschema.override

#--------------------------------------------------------------------
%package -n %{libname}
Summary:	Library for the %name greeter
Group:		System/Libraries
Obsoletes:	%{_lib}gdmreeter1 < 3.2.1-3

%description -n %{libname}
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

%files -n %{libname}
%{_libdir}/libgdm.so.%{major}*

#--------------------------------------------------------------------

%package -n %{girname}
Summary:        GObject Introspection interface description for %{name}
Group:          System/Libraries
Requires:       %{libname} = %{epoch}:%{version}-%{release}

%description -n %{girname}
GObject Introspection interface description for %{name}.

%files -n %{girname}
%{_libdir}/girepository-1.0/Gdm-%{gmajor}.typelib

#--------------------------------------------------------------------

%package -n %{develname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{epoch}:%{version}-%{release}
Provides:	%{name}-devel = %{epoch}:%{version}-%{release}

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%files -n %{develname}
%{_includedir}/gdm
%{_libdir}/libgdm.so
%{_libdir}/pkgconfig/gdm.pc
%{_datadir}/gir-1.0/Gdm-%{gmajor}.gir

#--------------------------------------------------------------------

%prep
%setup -q
cp data/Init.in data/Default.in
%apply_patches

%build
NOCONFIGURE=yes gnome-autogen.sh
%configure2_5x \
	--with-sysconfsubdir=X11/gdm \
	--with-dmconfdir=%{_sysconfdir}/X11/dm \
	--disable-static \
	--with-console-kit=no \
	--with-systemd \
	--with-plymouth

%make

%install
%makeinstall_std PAM_PREFIX=%{_sysconfdir}

# don't provide PreSession/PostSession, pam handle this
rm -f %{buildroot}%{_sysconfdir}/X11/PreSession/Default
rm -f %{buildroot}%{_sysconfdir}/X11/PostSession/Default

mkdir -p %{buildroot}%{_datadir}/hosts

%find_lang %{name} --with-gnome --all-name

mkdir -p %{buildroot}%{_var}/log/gdm %{buildroot}%{_sysconfdir}/X11/dm/Sessions

#remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/X11/gdm/PostLogin/Default.sample \
  %{buildroot}%{_datadir}/xsessions/gnome.desktop

find %{buildroot} -name '*.la' -delete

# (cg) The existing gdm file is what we really want for gdm-password
rm -f %{buildroot}%{_sysconfdir}/pam.d/gdm-password
ln -s gdm %{buildroot}%{_sysconfdir}/pam.d/gdm-password

## (cg) For ghost ownership
#touch %{buildroot}%{_sysconfdir}/dconf/db/%{name}

pushd %{buildroot}%{_sysconfdir}
ln -s X11/gdm
popd

# avoiding conflict with lightdm
mkdir -p %{buildroot}%{_libexecdir}/%{name}
mv %{buildroot}%{_bindir}/gdmflexiserver %{buildroot}%{_libexecdir}/%{name}/gdmflexiserver

echo "auth       optional pam_group.so" >> %{buildroot}%{_sysconfdir}/pam.d/gdm
echo "auth       optional pam_group.so" >> %{buildroot}%{_sysconfdir}/pam.d/gdm-autologin
echo "-session     optional      pam_systemd.so" >> %{buildroot}%{_sysconfdir}/pam.d/gdm-fingerprint
echo "-session     optional      pam_systemd.so" >> %{buildroot}%{_sysconfdir}/pam.d/gdm-smartcard

# added ROSA logo
install -dD %{buildroot}%{_datadir}/glib-2.0/schemas
install -m644 %{SOURCE1} %{buildroot}%{_datadir}/glib-2.0/schemas/
install -m644 %{SOURCE2} %{buildroot}%{_datadir}/pixmaps/

sed -i 's@#!/bin/sh@#!/bin/bash@g' %{buildroot}%{_sysconfdir}/X11/gdm/Xsession

%changelog
* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1:3.12.2-3
+ Revision: 7320e81
- MassBuild#440: Increase release tag

* Wed Jun 11 2014 Tigro <ashejn@gmail.com> 1:3.12.2-2
+ Revision: 5886202
- Merge remote-tracking branch 'origin/gnome312' into rosa2014.1

* Thu May 29 2014 Tigro <ashejn@gmail.com> 1:3.12.2-2
+ Revision: 1d81bed
- drop old patch

* Thu May 29 2014 Tigro <ashejn@gmail.com> 1:3.12.2-2
+ Revision: 8a78846
- update gdm-pam.d-configs patch for gdm 3.12.2

* Wed May 28 2014 Tigro <ashejn@gmail.com> 1:3.12.2-1
+ Revision: ef320ef
- drop pam patch for test

* Wed May 28 2014 Tigro <ashejn@gmail.com> 1:3.12.2-1
+ Revision: 66c0453
- drop file

* Tue May 20 2014 Tigro <ashejn@gmail.com> 1:3.12.2-1
+ Revision: 867c345
- update to 3.12.2

* Mon May 12 2014 Tigro <ashejn@gmail.com> 1:3.12.1-1
+ Revision: 9d75808
- drop some files and packages

* Mon May 12 2014 Tigro <ashejn@gmail.com> 1:3.12.1-1
+ Revision: f3089b7
- change paths

* Mon May 12 2014 Tigro <ashejn@gmail.com> 1:3.12.1-1
+ Revision: fd7738a
- added BR: dconf

* Mon May 12 2014 Tigro <ashejn@gmail.com> 1:3.12.1-1
+ Revision: 24e1957
- update to 3.12.1

* Fri Nov 22 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-12
+ Revision: a1c5ce6
- update logo to english rosa

* Mon Nov 11 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-12
+ Revision: 3d41442
- drop scrollkeeper update

* Thu Nov 07 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-11
+ Revision: fc29dad
- change #!/bin/sh to #!/bin/bash in /etc/X11/gdm/Xsession

* Thu Nov 07 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-10
+ Revision: ce4bafe
- drop some sources

* Sat Nov 02 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-10
+ Revision: fab50fa
- bump release

* Sat Nov 02 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-8
+ Revision: e5030c9
- Revert "drop chksession run and remove %{_sysconfdir}/X11/dm/"
- This reverts commit 39c1679423ca46ab4f0b3d18156f5d00dcd0e444.

* Sat Nov 02 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-9
+ Revision: 4a4575d
- Revert "fix path"
- This reverts commit 93bb74b5d4cc22de9618951da865f27b6caca8eb.

* Sat Nov 02 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-9
+ Revision: 6d1dfcf
- Revert "do not remove gnome.desktop"
- This reverts commit ebacab9e1ebc2bc68484fe35ec01f4826d12d054.

* Fri Oct 25 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-9
+ Revision: ebacab9
- do not remove gnome.desktop

* Wed Oct 23 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-9
+ Revision: 93bb74b
- fix path

* Wed Oct 23 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-9
+ Revision: 39c1679
- drop chksession run and remove %{_sysconfdir}/X11/dm/

* Sun Oct 13 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-8
+ Revision: 576dd39
- pack file

* Sun Oct 13 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-8
+ Revision: 709038a
- added ROSA logo

* Wed Oct 09 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-7
+ Revision: f56304c
- drop plymouth conflicts

* Tue Oct 08 2013 akdengi <kazancas@mandriva.ru> 1:3.8.1.1-6
+ Revision: 91db9f2
- install alternatives for gdmflexiserver only in initial, not upgrade

* Wed Sep 18 2013 akdengi <alexander.kazancev@rosalab.ru> 1:3.8.1.1-5
+ Revision: b2ea34d
- fix post

* Wed Sep 18 2013 akdengi <alexander.kazancev@rosalab.ru> 1:3.8.1.1-4
+ Revision: dcffcf2
- fix triggers

* Mon Sep 16 2013 Ilya Khokhryakov <ilyahohryakov@gmail.com> 1:3.8.1.1-3
+ Revision: 20ebf2d
- Added alternatives to avoid conflict with lightdm

* Thu Jul 25 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-2
+ Revision: a7734fb
- require package not typelib

* Thu Jul 25 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-2
+ Revision: 849cfd9
- fix typo

* Wed Jul 24 2013 Tigro <ashejn@gmail.com> 1:3.8.1.1-2
+ Revision: 451789c
- added R: typelib(Gmenu) force black screen

* Tue Jul 23 2013 Alexander Kazancev <kazancas@gmail.com> 1:3.8.3.1-1
+ Revision: 618f233
- Use %systemd_post gdm.service in %post section


